name: Test

on:
  pull_request:
  push:
  schedule:
    - cron: '0 6 * * *'

jobs:
  test:
    runs-on: ubuntu-latest
    strategy:
      fail-fast: false
      matrix:
        python-version:
          - '3.6'
          - '3.7'
          - '3.8'
          - '3.9'
          - '3.10'
          - 'pypy-3.6'
          - 'pypy-3.7'
          - 'pypy-3.8'
          - 'pypy-3.9'
        toxenv:
          - py-pytest6
          - py-pytest7
        include:
          - python-version: '3.6'
            toxenv: lint
    steps:
      - name: Check out repository
        uses: actions/checkout@v2

      - name: Set up Python
        uses: actions/setup-python@v2
        with:
          python-version: ${{ matrix.python-version }}

      - name: Install dependencies
        run: |
          python -m pip install --upgrade pip wheel
          python -m pip install --upgrade --upgrade-strategy=eager coverage tox

      - name: Run tests
        run: tox -e ${{ matrix.toxenv }}

      - name: Generate XML coverage report
        if: startsWith(matrix.toxenv, 'py')
        run: coverage xml

      - name: Upload coverage to Codecov
        if: startsWith(matrix.toxenv, 'py')
        uses: codecov/codecov-action@v2
        with:
          fail_ci_if_error: false

# vim:set et sts=2:
